## RiskyMod

A full-game overhaul that aims to bring it closer to RoR1's balance. My main priority is multiplayer, but the mod is balanced in solo as well.

I highly recommed installing https://thunderstore.io/package/Moffein/EliteReworks/ to go with this, and enabling the Celestine beta tweaks in the config.

Full change list can be found here. https://docs.google.com/document/d/1Igxdur0M33fdkcDLYgDEbLE0M4-89gSTorxgdn-oyKs/

This mod merges in fixes and tweaks from a bunch of other mods. If you have those mods installed, these fixes/changes will disable and the original mod will take priority (Except for Bandit Grace Period).

Feel free to take features of this mod and release them as standalone as long as you link the original GitHub repo in the README.

## Main Features

- Removed proc chains.
- Made difficulty scaling linear (exponential jump on-loop) and increased spawnrates.
- Oneshot Protection now works as you would expect.
	- Oneshot = Going from >90% HP to 0% HP in under 0.5s
	- Once triggered, you have to be out of danger (no damage for 7s) before it can be retriggered.
- Shields gate against HP damage like the Guardian's Heart in RoR1.
	- Transcendence/Perfected Affix disable Oneshot Protection due to having shieldgating built-in.
- Big balance pass over nearly all the items.
	- Bad items like Squid Polyps and Warbanners have gotten substantial buffs.
	- Strong damage items like AtGs and Elemental Bands now have lowered damage.
	- Most forms of range scaling have been removed.
- Drones performance now remains the same on all stages. (WiP)

## Other Changes

- Combat Shrines give less money, but drop items for the team on completion.
- Teleporter radius expands once the boss is dead.
- Tweaked Commencement
	- Only 2 pillars are required to activate the jump pads.
	- Pillars drop items for the team on completion, and you can complete as many as you want.

## Installation
Place RiskyMod.dll **AND** the **language folder** in /Risk of Rain 2/BepInEx/plugins/RiskyMod

## Planned Changes (Not implemented yet)

- More Survivor Tweaks
	- Mercenary
		- Shift-related QoL? Back when the 1.0 changes were initially introduced there was a lot of complaints about them, but I haven't heard much since then.
			- Revert 1.0 update dash distance change?
			- Should triple dash scale with move speed like Vanilla, or is no scaling preferred for better melee comboing?
			- Remove attack speed scaling so that triple dash can be controlled better lategame?
	- Captain
		- Turn beacons into deployables like Engi Turrets, but can't be targeted/killed by enemies.
		- Rework Hack/Resupply (Drone Amp/Mini Warbanner respectively?)
		- Buff Shock beacons?
		- Make Microbots only work with deployables/drones, or some other rework.
		- Add Admiral's fans as a selectable beacon.
	- Artificer
		- M1 reload scales with attack speed.
		- M1 4-hit combo.
		- Flamethrower scales with attack speed.
		- Figure out how Freeze should interact with bosses (inconsistency between Mithrix and every other boss).
		- Take a look at Ion Surge.
	- Loader Rework
	- Acrid Rework
- Enemy Tweaks?
- Void Rework?
	
## Credits

Drone Targeting fix - ZetTweaks

Squid Polyp distraction - DestroyedClone

Language Support - Anreol

Skill Icons - KoobyKarasu

## Changelog
`0.3.7`
- Items
	- Squid Polyp
		- Increased lifetime from 25s to 30s.
	- Infusion
		- No longer triggers when killing nonliving entities (Pots, Sky Meadow Rocks, etc.)
		- Now stacks infinitely.
			- Every 100HP gained causes the next 100HP to require an additional 150 kills.
				- Ex. first 100HP takes 100, second 100HP takes 250, third 400, etc.
				
	*Gonna keep my eye on this to see if it's too easy to get huge HP stacks.*
	
	- Happiest Mask
		- Now is guaranteed to trigger, but has a 10 second cooldown like Elemental Bands (works with Blast Shower).
	- H3AD-5T v2
		- Now gains +600%-6000% damage per stack.
		
	*This is the same scaling as AtGs and other Uncommon damage items. Concerned that it might be a bit strong due to the vanilla cooldown reduction per stack on top of damage per stack, but at the same time it's hard to actually stack this item due to being a Red and it requires you to change up your playstyle to make the most out of it.*
		
- Enemies
	- Grovetender
		- Tracking Wisps no longer trigger on-kill effects when destroyed.
		
	*Wasn't a fan of the wisps being unkillable in the standalone mod for this, so I'm only including the on-kill effect change. Will give this a another look if I ever get around to tweaking enemies in-depth.
	
- Survivors
	- Huntress
		- Added Arrow Rain Scepter variant. It's mostly the same as Scepter Mod's but with RiskyMod's changes.
	- MUL-T
		- Remembered to add config.
	- Rex
		- DIRECTIVE: Drill
			- Proc coefficient increased 0.5 -> 0.7
		- Utilities
			- Fixed whiffing at close range.
				- This still has awkward hit detection against certain enemies like Titans.
			- Changed push force
				- Can now push all bosses.
				- Now pushes in the direction you're looking, instead of straight ahead.
		- DIRECTIVE: Disperse
			- No longer Weakens.
			- Now heals 5% HP for every enemy hit.
		- Bramble Volley
			- No longer heals.
			- Now weakens.
			
		*Bramble Volley was a direct upgrade to Disperse in every way, with good damage and huge healing to offset its HP cost. With this change, I'm hoping to make it a choice between low-risk healing and higher-risk damage, rather than Bramble Volley just having everything.*
		
		- DIRECTIVE: Harvest
			- Fixed Vanilla nullref.
			- Fruit pickup range doubled.
			- Increased AOE from 2m -> 4m
			- Reduced heal from 25% HP -> 15% HP
			- Fruiting enemies move 80% slower.
			- Fruiting enemies have a 15% chance to drop fruits when attacked, in addition to the fruits they drop on-death.
			
		*Aiming to make this better at team support. Drop-on-hit is geared towards fighting super tanky bosses that refuse to die while the teleporter is already fully charged. Heals have been reduced due to fruits being more common now, but I need to play more to see if the healing needs to be adjusted further.*
			
`0.3.6`
- Readme fix.

`0.3.5`
- Run Scaling
	- Per-loop exponential scaling reduced from +20% -> +18%
	
*Felt that loop enemies were too spongy, so I'm reducing the amount the difficulty jumps.*

- Drones
	- Vagrant Nova resistance reduced 67% -> 50%
	- TC280
		- Removed 50% HP Bonus. Trying to get a feel for how tanky it is by default.

- Items
	- Crowbar
		- Now resets when an enemy heals to full health.
		
	*This should make this better against shielded enemies and healing enemies.*

	- Ukulele
		- Now gains +20% damage per stack.
		
	*Stacking Ukuleles is pretty underwhelming. I experimented with adding back the proc coefficient, but it brought back the same autokilling proc chains that this mod tries to avoid, so I'm going for the damage per stack route instead.*
		
	- Sentient Meathook
		- Now gains +25% damage per stack.
		
	*Same reasoning as Ukulele.*
		
	- Rose Buckler
		- Armor reduced 12(+12) -> 10(+10)
		
	*Felt weird that Aetherium's shielding core gives +10 armor per stack while this gives +12 armor per stack unconditionally. This'll still be better due to being +10 unconditional armor, but I have no intention to go below +10 armor per stack.*
	
	- Razor Wire
		- Increased range (16m-40m) -> (20m-50m)
		- Stacking increases damage by (+18%-90%) per stack.
		
	*Range reduction made this item too situational outside of specific builds, so the range is getting increased to start out at Focus Crystal/Tesla's radius. Stacking was underwhelming so it's getting a low damage boost per stack.*
	
	- Brilliant Behemoth
		- Removed range scaling.
		- Now gives +20% damage per stack.
		
	*Stacking Behemoths has always been pretty underwhelming in Vanilla. The range scaling goes against this mod's principle of removing range scaling from items, so it's been replaced with a low damage boost per stack. This damage bonus is lower than the damage bonus Green items get because Behemoths inherit the damage type properties of the damage that triggered it. Would like thoughts on this.*

- Proposed Item Changes (Unimplemented)
	- Clover
		- How to handle stacking? Stacking Clovers lags the game and makes chance-based items too dominant, but the luck is needed to offset Purity stacking. How should going beyond +1 luck work? Does it even need to be changed?

- Bandit
	- Adjusted primary animations to match vanilla.

- MUL-T
	- Nailgun
		- Damage reduced 70% -> 60%
		- Shot radius increased 0 -> 0.2
		- Now always fires the shotgun blast when canceling the skill.
	- Rebar Puncher
		- Damage increased 600% -> 720%
		
	*The Vanilla damage value has about as much DPS as Vanilla Huntress's M1. It only exists as a Wisp poking tool and nothing more than that. It can be worked into swapping combos for quick burst damage, but swapping is inferior and scales worse than just holding M1 and Shift with the Nailgun.*
	
	- Scrap Launcher
		- Damage increased 360% -> 390%
		- Removed random spread.
		
	*Wanted to make this reloadable like Bandit's primaries but I couldn't figure out MUL-T's skill stuff so that's been put aside.*
	
	- Power-Saw
		- Now gives barrier on-hit.
		- Hitbox size increased 50%
		- Reworked self-force to be more controllable.
			- No longer pulls you forwards.
			- Hitting an enemy breaks your fall and pushes you upwards a bit if you are midair.
	- Blast Canister
		- Now knocks flying enemies downwards.
	- Power Mode
		- Reduced armor from 100 to 60.
	- Retool
		- Now reloads your primary skill.
		
	*This has a built-in 0.5s cooldown. Was considering removing it but then it re-introduced Rebar quickswap which overshadows the other primaries. If there's demand for it, I'll see if I can balance around it, but for now I'll leave the cooldown in.*
	
*MUL-T is in a weird spot where he's really strong but no one wants to play him because he's boring. All his primaries are designed around weapon swapping, but they just get overshadowed by simply holding M1 on the Nailgun, both with and without Power Mode. I've nerfed Nailgun and Powermode, and buffed weapon swapping and the other primaries, but I still think that Nailgun will probably remain the default pick anyways.*